
C
C     This code is distributed under the terms and conditions of the
C     CCP4 licence agreement as `Part 2' (Annex 2) software.
C     A copy of the CCP4 licence can be obtained by writing to the
C     CCP4 Secretary, Daresbury Laboratory, Warrington WA4 4AD, UK.
C
C
      SUBROUTINE ELDEN_ANISO(nl1,nl2,nl3,ndens,nmodel,DEN)
      use ncs_constraints
      use CellAndSymmetry
      use refi_flags
      IMPLICIT NONE
C-----------------------------------------------------------------
C---------           SPACE GROUP GENERAL
C---This subroutine adds ontribution of atoms with aniso B-value
C---to electron desnity. 
C-------------------------------------------------------------------
      INCLUDE 'atom_com.fh'
      include 'models.fh'
      INCLUDE 'vitals.fh'
      INCLUDE 'const.fh'
      include 'anom.fh'
C
      integer nl1,nl2,nl3,ndens,nmodel
      REAL   DEN(nl1,nl2,nl3,ndens)
      REAL*8 GAUSSD( 5001)
C
C---Local variables
      real    uaniso_list_an(6,200)
      REAL    XA_LIST(3,200),UANISO_LIST(6,200),UANISO_CELL(6),
     +        XYZ_FRAC(3)
      INTEGER INDSYM_LIST(200)
      integer in
      INTEGER I,NX50,NY50,NZ50,IA,IA1,IA11,IL,IL1,NATOM_LIST,ILIST,
     &        IANISO,IG,IDET,ISZL,ISZU,IZ1,IZ,ISYL,ISYU,IY1,IY,IY2,
     &        ISXL,ISXU,IX1,IX,IX2,ID31,IZ2,nmod_anom,nadn,im,wave_pos
      REAL XLOW,YLOW,ZLOW,XUPPER,YUPPER,ZUPPER,SX,SY,SZ,DLIMIT,CSA2,D22,
     &     D238,UEIGEN_MAX,U11,UL,D1,X1,Y1,Z1,XC,YC,ZC,RADZ,SZL,SZU,DZ,
     &     D2,DZO,DZO2,D7,RADY,ZCOSA,SYL,SYU,DZCSA2,DZROX,DZROY,DZCSB,
     &     DY,DYO,DYO2,DYZO,DYZ,DXMIN,DSQMIN,D4,RADX,SXL,SXU,DYZROX,
     &     DXO2PYO2,DX,DXO2,DSQ,DXYO,DXZO,DXYO2,DSQ1,
     &     XDELTA,DXO,DXZO2,DYZO2
      real d238_anom
      REAL*8    CL1(5)
      real uaniso_init_an(6)
      real xyz(3),xyz_1(3)
      real uan(6),uan_1(6),uan_anom_1(6),uan_anom(6)
      REAL FU_ANISO(6,5,MAXNSF),UL_ANISO(6,5),DET_U(5),
     +     XUX(5),XUXZ(5),XUXY(5),UL_INVERT(6,5),UANISO_F(6),
     +     UANISO_O(6)
      real ul_aniso_an(6),ul_invert_an(6)
      real det_u_an,xux_an,xuxy_an,xuxz_an,clan,facan
      real*8 fac
      LOGICAL ERROR, anom
      CHARACTER LINE*256
c
      real uu_ncs(6,6,192)
c

      do in=1,n_ncs_const
         call find_conv_matrix(ncs_c_rot(1:3,1:3,in),uu_ncs(1:6,1:6,in))
      enddo
C
C----Find extension limits for asymmetric unit
      CALL ASYMLIM_FRAC(DDLIM,XLOW,YLOW,ZLOW,XUPPER,YUPPER,ZUPPER)
C
C---Convert form factors to cell B-values in cell edges. It should be removed
C---from here and put to celsym.f90 or something like that
      CALL FBS2ANISO(NGAUS,MAXNSF,CS_NSFATM,CS_B,FU_ANISO)
      SX     = CS_CELL(1)/NX
      SY     = CS_CELL(2)/NY
      SZ     = CS_CELL(3)/NZ
      COSAST = (COSA-COSB*COSG)/(SING*SING)
      DLIMIT = DDLIM
C
      DO  I=1,5000
        GAUSSD(I)=EXP(-.002d0*I+.002d0)
      ENDDO
      GAUSSD(5001) = 0.0d0
      CSA2 = COSA*2.0
C ---
      D22 = SX*SY*SZ*COSZ*SING/TWOPI**1.5
C
      nmod_anom=0
      if (DPPI_sad.or.DPPI_sadh.or.DPPI_sras.or.DPPI_mad) then
        wave_pos = dataset_wavenum(dataset_order(2))
        if (DPPI_sad.or.DPPI_sadh.or.DPPI_sras) nmod_anom=1
        if (DPPI_mad) nmod_anom=2
      endif
      NX50 = 500*NX
      NY50 = 500*NY
      NZ50 = 500*NZ
C----Loop over all atoms in all models
      do im=1,nmodel
      anom=.false.
      if ((DPPI_sad.or.DPPI_sadh.or.DPPI_mad).and.im.eq.1) anom=.true.
      if (DPPI_sras.and.im.eq.2) anom=.true.
c non-anomalous density (order) number corresponding to model im
      nadn = 1 + (1+nmod_anom)*(im-1)
      DO     IA=1,N_ATOM_mod(im)
        IA1 = ATOM_REF_mod_FLAG(IA,im)/10
        IA11 = ATOM_REF_mod_FLAG(IA,im)-IA1*10
        IF(IA11.LE.1) GOTO 500
        IF(U_ANISO_mod(2,IA,im).LE.0..or.OCCUP_mod(IA,im).LE.0.)GOTO 500
C
C---If atom has aniso B-value

C
C---Add NCS here
        IL   = ID_SF_mod(IA,im)
        D238 = OCCUP_mod(IA,im)*D22
        d238_anom = occup_anom_mod(ia,im)*d22
        IL1  = CS_NELEC(IL)
        CALL FIND_MAX_EIGEN(U_ANISO_mod(1,IA,im),UEIGEN_MAX) 
        U11  = 2.0*UEIGEN_MAX
        IF(IL1.GE.16)U11=AMAX1(U11,0.4)
        UL   = 0.70+U11
        IF(IL1.EQ.1)UL = 0.38+U11
        D1   = DLIMIT*UL
C
C---List of all atoms contributing to asymmetric unit. B values of
C---symmetry related atoms are different from those of original.
        xyz_1 = xyz_crd_mod(1:3,ia,im)
        uan_1 = u_aniso_mod(1:6,ia,im)
        uan_anom_1 = u_anom_mod(1:6,ia,im)
        do in=1,n_ncs_const
           xyz = matmul(ncs_c_rot(1:3,1:3,in),xyz_1)+ncs_c_tr(1:3,in)
           xyz_frac = matmul(cs_ort_to_frac,xyz)
           uan = matmul(transpose(uu_ncs(1:6,1:6,in)),uan_1)
           uaniso_cell = matmul(transpose(uuorth2cell),uan)
           uan_anom = matmul(transpose(uu_ncs(1:6,1:6,in)),uan_anom_1)
           uaniso_init_an = matmul(transpose(uuorth2cell),uan_anom)

c        CALL MAT2VEC(3,3,CS_ORT_TO_FRAC,XYZ_CRD_mod(1,IA,im),XYZ_FRAC,
c     &    ERROR)
c        CALL MAT2VECT(6,6,UUORTH2CELL,U_ANISO_mod(1,IA,im),UANISO_CELL,
c     &    ERROR)
c        call mat2vect(6,6,uuorth2cell,u_anom_mod(1,ia,im),uaniso_init_an
c     &    ,error)
           CALL ATLIST_ANISO(XYZ_FRAC,UANISO_CELL,uaniso_init_an,
     &          XA_list,UANISO_LIST,uaniso_list_an, XLOW,YLOW,ZLOW,
     &          XUPPER,YUPPER,ZUPPER,INDSYM_LIST,NATOM_LIST)
C
C----Loop over list of atoms which contribute to "asymmetric" unit
           DO    ILIST=1,NATOM_LIST
              X1 = XA_list(1,ILIST)*CS_CELL(1)
              Y1 = XA_list(2,ILIST)*CS_CELL(2)
              Z1 = XA_list(3,ILIST)*CS_CELL(3)
              DO     IANISO=1,6
                 UANISO_F(IANISO) = UANISO_LIST(IANISO,ILIST)
              ENDDO
              CALL MAT2VECT(6,6,UUCELL2ORTH,UANISO_F,UANISO_O,ERROR)
              DO    IG=1,NGAUS
                 DO   IANISO=1,6
                    UL_ANISO(IANISO,IG) = FU_ANISO(IANISO,IG,IL) +
     +                   UANISO_O(IANISO)
                 ENDDO
              ENDDO
              if ( anom.and.cs_anom(il)) then
c     call mat2vect(6,6,uucell2orth,uaniso_list_an(1,ilist),
c     &            uaniso_o,error)
c     call mat2vect(6,6,uucell2orth,uaniso_list(1,ilist),
c     &            uaniso_o,error)
                 ul_aniso_an(1:6) = uaniso_o(1:6)
                 call aniso_invert1(ul_aniso_an,det_u_an,ul_invert_an)
              endif
C
C---Invert B-values and calculate their determinants.
              CALL ANISO_INVERT(NGAUS,UL_ANISO,DET_U,UL_INVERT)
              DO    IDET = 1,NGAUS
                 IF(DET_U(IDET).LE.0.0) THEN
                    WRITE(LINE,'(A,2I5)')
     &                   'Problem with atom in ELDEN',IA,
     &                   INDSYM_LIST(ILIST)
                    WRITE(*,*)(U_ANISO(IANISO,IA),IANISO=1,6)
                    CALL ERRWRT(-1,LINE)
                    GOTO 500
                 ENDIF
              ENDDO
              DO     IG=1,NGAUS
                 CL1(IG) = D238*CS_A(IG,IL)/SQRT(DET_U(IG))
              ENDDO
              if (anom.and.cs_anom(il)) then
                 clan = d238_anom*
     &                f2prime(t2at(il),wave_pos)/sqrt(det_u_an)
              endif

              XC   = X1/SX
              YC   = Y1/SY
              ZC   = Z1/SZ
              RADZ = SQRT(D1)/(SZ*COSZ)
              SZL  = ZC - RADZ
              SZU  = ZC + RADZ
c     if(szu.lt.0.) cycle
              ISZL = INT(SZL+501.0)
              ISZU = INT(SZU+500.0)
              DO      IZ1 = ISZL,ISZU
                 IZ  = IZ1 - 500
                 IZ2 = MOD(IZ+NZ50,NZ) + 1
                 IF(IZ2.GT.N3)GO TO 300
                 IF(IZ2.LT.1) GO TO 300
                 DZ   = IZ*SZ-Z1
                 D2   = DZ*DZ
                 DZO  = DZ*RO_UNIT(3,3)
                 DZO2 = DZO*DZO
                 D7   = D1-DZO2
                 IF (D7.LT.0.0)GO TO 300
                 DO    IG=1,ngaus
                    XUXZ(IG) = DZO2*UL_INVERT(3,IG)
                 ENDDO 
                 if(anom.and.cs_anom(il)) then
                    xuxz_an = dzo2*ul_invert_an(3)
                 endif
                 RADY   = SQRT(D7)/(SY*SING)
                 ZCOSA  = DZ*COSAST/SY
                 SYL    = YC - RADY - ZCOSA
                 SYU    = YC + RADY - ZCOSA
c     if(syu.lt.0.0) cycle
                 ISYL   = INT(SYL+501.0)
                 ISYU   = INT(SYU+500.0)
                 DZCSA2 = DZ*CSA2
                 DZROX  = DZ*RO_UNIT(1,3)
                 DZROY  = RO_UNIT(2,3)*DZ
                 DZCSB  = DZ*COSB
                 DO     IY1 = ISYL,ISYU
                    IY  = IY1-500
                    IY2 = MOD(IY+NY50,NY)+1
C---  CHECK FOR IY2 WITHIN ASYMMETRIC UNIT
                    IF(IY2.GT.N2)GO TO 290
                    IF(IY2.LT.1) GO TO 290
                    DY     = IY*SY-Y1
                    DYO    = DY*RO_UNIT(2,2) + DZROY
                    DYO2   = DYO*DYO
c     if(dyo2.gt.d1) cycle
                    DYZO   = DYO*DZO
                    DYZO2  = 2.0*DYZO
                    DYZ    = D2 + (DZCSA2 + DY)*DY
                    DXMIN  =-DY*COSG-DZCSB
                    DSQMIN = DYZ-DXMIN**2
                    DO    IG=1,ngaus
                       XUXY(IG) = XUXZ(IG) +  DYO2*UL_INVERT(2,IG) +
     +                      DYZO2*UL_INVERT(6,IG)
                    ENDDO
                    if(anom.and.cs_anom(il)) then
                       xuxy_an = xuxz_an + dyo2*ul_invert_an(2) +
     &                      dyzo2*ul_invert_an(6)
                    endif
                    D4       = D1-DSQMIN
                    IF(D4.LT.0.0) GOTO 290
                    RADX     = SQRT(D4)/(SX*SING)
                    XDELTA   = DXMIN/SX
                    SXL      = XC - RADX + XDELTA
                    SXU      = XC + RADX + XDELTA
c     if(sxu.lt.0.) cycle
                    ISXL     = INT(SXL+501.0)
                    ISXU     = INT(SXU+500.0)
                    DYZROX   = DY*RO_UNIT(1,2) + DZROX
                    DXO2PYO2 = DYO2 + DZO2
c     if(dxo2pyo2.gt.d1) cycle
                    DO      IX1 = ISXL,ISXU
                       IX   = IX1 - 500
                       IX2  = MOD(IX+NX50,NX)+1
C---  CHECK FOR IX2 WITHIN ASYMMETRIC UNIT
                       IF(IX2.GT.N1)GO TO 280
                       IF(IX2.LT.1) GO TO 280
                       DX   = IX*SX-X1
                       DXO  = DX*RO_UNIT(1,1) + DYZROX
                       DXO2 = DXO*DXO
                       DSQ  = DXO2 + DXO2PYO2
                       IF(DSQ.GT.D1)GO TO 280
                       FAC   = 0.0
                       DXYO  = DXO*DYO
                       DXZO  = DXO*DZO
                       DXYO2 = 2.0*DXYO
                       DXZO2 = 2.0*DXZO
                       DO    IG = 1,NGAUS
                          XUX(IG) = XUXY(IG) + UL_INVERT(1,IG)*DXO2   + 
     +                         UL_INVERT(4,IG)*DXYO2  +
     +                         UL_INVERT(5,IG)*DXZO2 
                          DSQ1 = XUX(IG)*250.0+1.0
                          ID31 = MIN1(DSQ1,5001.1)
                          IF(ID31.LE.10000) then
                             FAC  = FAC + CL1(IG)*GAUSSD(ID31)
                          endif
                       ENDDO
                       DEN(IX2,IY2,IZ2,nadn) = 
     &                      DEN(IX2,IY2,IZ2,nadn) + FAC
                       if(anom.and.cs_anom(il)) then
                          xux_an = xuxy_an + ul_invert_an(1)*dxo2 +
     &                         ul_invert_an(4)*dxyo2 +
     &                         ul_invert_an(5)*dxzo2
                          dsq1 = xux_an*250.0 + 1.0
                          id31 = min1(dsq1,5001.1)
                          facan = gaussd(id31)*clan
                          den(ix2,iy2,iz2,nadn+1) = 
     &                         den(ix2,iy2,iz2,nadn+1) + facan
                       endif
 280                   CONTINUE
                    ENDDO
 290                CONTINUE
                 ENDDO
 300             CONTINUE
              ENDDO
           ENDDO
        enddo
 500    CONTINUE
      ENDDO
      enddo
      RETURN
      END
C
      SUBROUTINE GRAD_ANISO(nl1,nl2,nl3,ndens,nmodel,DEN,GX,GU1,GQ,
     &     gu1_anom,gq_anom)
      use ncs_constraints
      use CellAndSymmetry
      use refi_flags
      implicit none
C------------------------------------------------------------------
C--------         SPACE GROUP GENEREAL          -------------------
C---Calculates gradients. Atoms with anisotropic B-values
C------------------------------------------------------------------
      INCLUDE 'atom_com.fh'
      include 'models.fh'
      INCLUDE 'vitals.fh'
      INCLUDE 'const.fh'
      include 'anom.fh'

C
      integer nl1,nl2,nl3,ndens,nmodel
      REAL   GX(*),GU1(*),GQ(*)
      real   gu1_anom(*),gq_anom(*)
      real   DEN(nl1,nl2,nl3,ndens)
C
C---Local variables
      integer in
      integer i,ix,iy,iz,ix1,iy1,iz1,ix2,iy2,iz2,ianiso,iq,isym,it
      integer ixl,ixu,iyl,iyu,izl,izu,ixt,ilist,ia,ia1,ia11,il,il1
      integer npoints,nx50,ny50,nz50
      integer natom_list
      integer id31,ig,idet,wave_pos,nmod_anom,im,nadn
      REAL*8 GAUSS(5001)
      real uaniso_init_an(6)
      REAL XA_LIST(3,250),FU_ANISO(6,5,MAXNSF),UANISO_INIT(6),
     +     UANISO_LIST(6,250),UL_INVERT(6,5),XUX(5),XUXY(5),XUXZ(5),
     +     UL_ANISO(6,5),DET_U(5),DDET_UDU(6,5), CL1(5),CLB(5),CLQ(5)
      REAL DUDU(6,6,5),GU(6),GUU(6),XYZ(3),XYZ1(3)
      real xyz_1(3)
      real uan_1(6),uan_anom_1(6)
      real uaniso_list_an(6,250)
      real  GXP(3),XYZ_FRAC(3),UANISO_F(6),UANISO_O(6),GU11(6)
      real gu_anom(6)
      real ul_aniso_an(6),ul_invert_an(6),dudu_an(6,6),ddet_udu_an(6)
      REAL*8 G1X(5),G1Y(5),G1Z(5),GB0(5),GBXX(5),GBYY(5),GBZZ(5),
     &       GBXY(5),GBXZ(5),GBYZ(5)
      real*8 gqq,gqq_anom
      real sx,sy,sz,u11,xl,xu,yl,yu,zl,zu,x1,y1,z1,x1p,y1p,z1p
      real u11_anom
      real xlow,xupper,ylow,yupper,zlow,zupper
      real ueigen_max,rad,radx,rady,radz,radsq
      real dx,dy,dz,dxo,dyo,dzo,dxzo,dyzo,d4,d7,d31,d238,d22,dyz1
      real d238_anom
      real dd,dxyo2,dyo2pzo2,dzcsa2,dsq,dsq1,dxo2,dxmin,dxyo,dzroy
      real dzz
      real dxzo2,dzo2,dzcsb,dyo2,dyzrox,dzrox
      real dlim
      real dd_an,dan31,det_u_an
      real*8 g1x_an,g1y_an,g1z_an,gb0_an,gbxx_an,gbyy_an,gbzz_an
      real*8 gbxy_an,gbxz_an,gbyz_an
      real csa2,csb2,csg2
      real xux_an,xuxy_an,xuxz_an,cl_an,clq_an,clb_an
      INTEGER INDSYM_LIST(250)
      LOGICAL ERROR, anom
      CHARACTER LINE*128
c
      real uu_ncs(6,6,192)
c
      do in=1,n_ncs_const
         call find_conv_matrix(ncs_c_rot(1:3,1:3,in),uu_ncs(1:6,1:6,in))
      enddo
C
C-----There are redundant points on the asymmetric unit. Reduce density
C----to real asymmetruic unit
      CALL REDALLI(N1,N2,N3,NX,NY,NZ,ndens,ROT,TR,NumSymmetry,DEN)
C
C----Find extension limits for asymmetric unit
      CALL ASYMLIM_FRAC(DGLIM,XLOW,YLOW,ZLOW,XUPPER,YUPPER,ZUPPER)
C
C---Convert form factors to cell B-values in cell edges. It should be removed
C---from here and put to celsym.f90 or something like that

      CALL FBS2ANISO(NGAUS,MAXNSF,CS_NSFATM,CS_B,FU_ANISO)
      SX      = CS_CELL(1)/NX
      SY      = CS_CELL(2)/NY
      SZ      = CS_CELL(3)/NZ
      COSAST  = (COSA-COSB*COSG)/(SING*SING)
      DO    I=1,5000
         GAUSS(I)=EXP(-.002d0*I+.002d0)
      ENDDO
      GAUSS(5001)=0.0d0
C-------------------------------------------------------------------
      D22=CS_CELL(1)*CS_CELL(2)*CS_CELL(3)*COSZ*SING/TWOPI**1.5
C
C---Initialisation should be done before this subroutine
      IT   = 1
      IXT  = 1
      IQ   = 1
      NX50 = 50*NX
      NY50 = 50*NY
      NZ50 = 50*NZ
      CSA2        = 2.0*COSA
      nmod_anom=0
      if (DPPI_sad.or.DPPI_sadh.or.DPPI_sras.or.DPPI_mad) then
        wave_pos = dataset_wavenum(dataset_order(2))
        if (DPPI_sad.or.DPPI_sadh.or.DPPI_sras) nmod_anom=1
        if (DPPI_mad) nmod_anom=2
      endif

      do  im=1,nmodel
      anom=.false.
      if ((DPPI_sad.or.DPPI_sadh.or.DPPI_mad).and.im.eq.1) anom=.true.
      if (DPPI_sras.and.im.eq.2) anom=.true.
c non-anomalous density (order) number corresponding to model im
      nadn = 1 + (1+nmod_anom)*(im-1)
      DO    IA=1,N_ATOM_mod(im)
        IA1 = ATOM_REF_mod_FLAG(IA,im)/10
        IA11 = ATOM_REF_mod_FLAG(IA,im)-IA1*10
        IF(IA11.LE.0.OR.OCCUP_mod(IA,im).LE.0.0) GOTO 500
        IF(IA11.LE.2.OR.U_ANISO_mod(2,IA,im).LE.0.0) GOTO 498
C
C---Add NCS here
        D238 = D22*OCCUP_mod(IA,im)
        d238_anom = d22*occup_anom_mod(ia,im)
        IL   = ID_SF_mod(IA,im)
        IL1  = CS_NELEC(IL)
        CALL FIND_MAX_EIGEN(U_ANISO_mod(1,IA,im),UEIGEN_MAX)
        U11  = 2.0*UEIGEN_MAX

c        call find_max_eigen(u_anom_mod(1,ia,im),ueigen_max)
c        u11_anom = 2.0*ueigen_max
        u11_anom = U11
        DLIM = DGLIM
        IF(IL1.EQ.1) DLIM = 3.5
        IF(IL1.GE.16)U11  = AMAX1(U11,0.60)
        RADSQ = DLIM*(U11+0.70)
        RAD   = SQRT(RADSQ)
        RADZ  = RAD/COSZ
C
C---  List of all atoms contributing to asymmetric unit. B values of
C---  symmetry related atoms are different from those of original.
        xyz_1 = xyz_crd_mod(1:3,ia,im)
        uan_1 = u_aniso_mod(1:6,ia,im)
        uan_anom_1 = u_anom_mod(1:6,ia,im)
        do in=1,n_ncs_const
           xyz = matmul(ncs_c_rot(1:3,1:3,in),xyz_1)+ncs_c_tr(1:3,in)
           xyz_frac = matmul(cs_ort_to_frac,xyz)

           uaniso_init = matmul(transpose(uu_ncs(1:6,1:6,in)),uan_1)
           uaniso_init = matmul(transpose(uuorth2cell),uaniso_init)
           
           uaniso_init_an = 
     &          matmul(transpose(uu_ncs(1:6,1:6,in)),uan_anom_1)
           uaniso_init_an = 
     &          matmul(transpose(uuorth2cell),uaniso_init_an)
c        CALL MAT2VEC(3,3,CS_ORT_TO_FRAC,XYZ_CRD_mod(1,IA,im),XYZ_FRAC,
c     &    ERROR)
c        CALL MAT2VECT(6,6,UUORTH2CELL,U_ANISO_mod(1,IA,im),UANISO_INIT,
c     &    ERROR)
c        call mat2vect(6,6,uuorth2cell,u_anom_mod(1,ia,im),uaniso_init_an
c     &       ,error)
           CALL ATLIST_ANISO(XYZ_FRAC,UANISO_INIT,uaniso_init_an,
     &          XA_list,UANISO_LIST,uaniso_list_an,XLOW,YLOW,ZLOW,
     &          XUPPER,YUPPER,ZUPPER,INDSYM_LIST,NATOM_LIST)
C
C---- Loop over list of atoms which contribute to "asymmetric" unit
           DO    ILIST=1,NATOM_LIST
C
C---- Initialisation
              DO    IG=1,NGAUS
                 G1X(IG)  = 0.0
                 G1Y(IG)  = 0.0
                 G1Z(IG)  = 0.0
                 GB0(IG)  = 0.0
                 GBXX(IG) = 0.0
                 GBYY(IG) = 0.0
                 GBZZ(IG) = 0.0
                 GBXY(IG) = 0.0
                 GBXZ(IG) = 0.0
                 GBYZ(IG) = 0.0
              ENDDO
              g1x_an = 0.0
              g1y_an = 0.0
              g1z_an = 0.0
              gb0_an = 0.0
              gbxx_an = 0.0
              gbyy_an = 0.0
              gbzz_an = 0.0
              gbxy_an = 0.0
              gbxz_an = 0.0
              gbyz_an = 0.0
              ISYM    = INDSYM_LIST(ILIST)
              X1      = XA_list(1,ILIST)*CS_CELL(1)
              Y1      = XA_list(2,ILIST)*CS_CELL(2)
              Z1      = XA_list(3,ILIST)*CS_CELL(3)
              DO     IANISO=1,6
                 UANISO_F(IANISO) = UANISO_LIST(IANISO,ILIST)
              ENDDO
              CALL MAT2VECT(6,6,UUCELL2ORTH,UANISO_F,UANISO_O,ERROR) 
              DO    IG=1,NGAUS
                 DO   IANISO=1,6
                    UL_ANISO(IANISO,IG) = FU_ANISO(IANISO,IG,IL) +
     +                   UANISO_O(IANISO)
                 ENDDO
              ENDDO
C
C---  Invert B-values and calculate corresponding derivatives.
              CALL ANISO_INVERT(NGAUS,UL_ANISO,DET_U,UL_INVERT)
              DO    IDET = 1,NGAUS
                 IF(DET_U(IDET).LE.0.0) THEN
                    WRITE(LINE,'(A,2I5)')
     &                   'Problem with atom in GRAD ',IA,
     &                   INDSYM_LIST(ILIST)
                    CALL ERRWRT(-1,LINE)
                    GOTO 498
                 ENDIF
              ENDDO
c
              if(anom.and.cs_anom(il)) then
c     uaniso_f(1:6) = uaniso_list_an(1:6,ilist)
c     uaniso_f(1:6) = uaniso_list(1:6,ilist)
c     call mat2vect(6,6,uucell2orth,uaniso_f,uaniso_o,error)
                 ul_aniso_an(1:6) = uaniso_o(1:6)
                 call aniso_invert1(ul_aniso_an,det_u_an,ul_invert_an)
              endif
c
              DO     IG=1,NGAUS
                 CL1(IG) = D238*CS_A(IG,IL)/SQRT(DET_U(IG))
                 CLB(IG) = 0.5*CL1(IG)
                 CLQ(IG) = D22*CS_A(IG,IL)/SQRT(DET_U(IG))
              ENDDO
              if(anom.and.cs_anom(il)) then
                 cl_an = d238_anom*
     &                f2prime(t2at(il),wave_pos)/sqrt(det_u_an)
                 clb_an = 0.5*cl_an
                 clq_an = d22*f2prime(t2at(il),wave_pos)/sqrt(det_u_an)
              endif
              ZL  = Z1 - RADZ
              ZU  = Z1 + RADZ
c     if(zu.lt.0.0) cycle
              IZL = INT(ZL/SZ+501.)
              IZU = INT(ZU/SZ+500.)
              NPOINTS = 0
              DO     IZ1=IZL,IZU
                 IZ  = IZ1-500
                 IZ2 = MOD(IZ+NZ50,NZ)+1
                 IF(IZ2.GT.N3)GO TO 300
                 IF(IZ2.LT.1) GO TO 300
                 DZ   = IZ*SZ-Z1
                 DZZ  = DZ*DZ
                 DZO  = DZ*RO_UNIT(3,3)
                 DZO2 = DZO*DZO
                 D7   = RADSQ-DZO2
                 IF (D7.LT.0.0)GO TO 300
                 RADY = SQRT(D7)/SING
                 Y1P  = Y1  - DZ*COSAST
                 YL   = Y1P - RADY
                 YU   = Y1P + RADY
c     if(yu.lt.0.0) cycle
                 IYL  = INT(YL/SY+501.)
                 IYU  = INT(YU/SY+500.)
                 IF(IYU.LT.IYL)GO TO 300
                 DO    IG=1,NGAUS
                    XUXZ(IG) = UL_INVERT(3,IG)*DZO2
                 ENDDO 
                 if(anom.and.cs_anom(il)) then
                    xuxz_an = ul_invert_an(3)*dzo2
                 endif
                 DZROX  = DZ*RO_UNIT(1,3)
                 DZROY  = DZ*RO_UNIT(2,3)
                 DZCSA2 = DZ*CSA2
                 DZCSB  = DZ*COSB
                 DO     IY1=IYL,IYU
                    IY  = IY1-500
                    IY2 = MOD(IY+NY50,NY)+1
C---  CHECK FOR IY2 WITHIN ASYMMETRIC UNIT
                    IF(IY2.GT.N2)GO TO 290
                    IF(IY2.LT.1) GOTO 290
                    DY     = IY*SY-Y1
                    DXMIN  =-DY*COSG - DZCSB
                    DYZ1   = DZZ + DY*(DZCSA2 + DY)
                    D4     = RADSQ - DYZ1 + DXMIN**2
                    IF (D4.LT.0.0)GO TO 290
                    RADX   = SQRT(D4)/SING
                    X1P    = X1  + DXMIN
                    XL     = X1P - RADX
                    XU     = X1P + RADX
                    IXL    = INT(XL/SX+501.)
                    IXU    = INT(XU/SX+500.)
                    IF(IXU.LT.IXL)GO TO 290
                    DYO    = DY*RO_UNIT(2,2) + DZROY
                    DYO2   = DYO*DYO
c     if(dyo2.gt.radsq) cycle
                    DYZO   = DYO*DZO
                    DO   IG=1,NGAUS
                       XUXY(IG) = XUXZ(IG) + DYO2*UL_INVERT(2,IG) +
     +                      2.0*UL_INVERT(6,IG)*DYZO
                    ENDDO
                    if(anom.and.cs_anom(il)) then
                       xuxy_an = xuxz_an + dyo2*ul_invert_an(2) +
     &                      2.0*ul_invert_an(6)*dyzo
                    endif
                    DYZROX   = DY*RO_UNIT(1,2) + DZROX
                    DYO2PZO2 = DYO2 + DZO2
                    DO     IX1=IXL,IXU
                       IX  = IX1-500
C---  CHECK FOR IX2 WITHIN ASYMMETRIC UNIT
                       IX2 = MOD(IX+NX50,NX)+1
                       IF(IX2.GT.N1)GO TO 280
                       IF(IX2.LT.1) GO TO 280
                       DD = DEN(IX2,IY2,IZ2,nadn)
                       dd_an = 0.0
                       if(anom.and.cs_anom(il)) then
                          dd_an = den(ix2,iy2,iz2,nadn+1)
                       endif
                       IF(DD.eq.0.0.and.dd_an.eq.0.0)GOTO 280
                       DX    = IX*SX-X1
                       DXO   = DX*RO_UNIT(1,1) +  DYZROX 
                       DXO2  = DXO*DXO
                       DSQ   = DXO2 + DYO2PZO2 
                       IF(DSQ.GT.RADSQ)GO TO 280
                       DXYO  = DXO*DYO
                       DXZO  = DXO*DZO
                       DXYO2 = 2.0*DXYO
                       DXZO2 = 2.0*DXZO
C
C---We could use here variable integration if we would like to do so.
C---But then we could loose speed. (!!!!!)
                       DO   IG=1,NGAUS
                          XUX(IG)  = XUXY(IG) + DXO2*UL_INVERT(1,IG) + 
     &                         UL_INVERT(4,IG)*DXYO2 + 
     &                         UL_INVERT(5,IG)*DXZO2    
                          DSQ1     = XUX(IG)*250.0+1.0
                          ID31     = MIN1(DSQ1,5001.1)
                          IF(ID31.LT.5001) THEN
                             D31      = GAUSS(ID31)*DD
                             G1X (IG) = G1X (IG) +  DXO*D31
                             G1Y (IG) = G1Y (IG) +  DYO*D31
                             G1Z (IG) = G1Z (IG) +  DZO*D31
                             GB0 (IG) = GB0 (IG) +      D31
                             GBXX(IG) = GBXX(IG) + DXO2*D31
                             GBYY(IG) = GBYY(IG) + DYO2*D31
                             GBZZ(IG) = GBZZ(IG) + DZO2*D31
                             GBXY(IG) = GBXY(IG) + DXYO*D31
                             GBXZ(IG) = GBXZ(IG) + DXZO*D31
                             GBYZ(IG) = GBYZ(IG) + DYZO*D31
                             NPOINTS = NPOINTS + 1
                          ENDIF
                       ENDDO
                       if(anom.and.cs_anom(il)) then
                          xux_an = xuxy_an + dxo2*ul_invert_an(1) +
     &                         ul_invert_an(4)*dxyo2 + 
     &                         ul_invert_an(5)*dxzo2
                          dsq1 = xux_an*250.0+1.
                          id31 = min1(dsq1,5001.1)
                   
                          dan31 = gauss(id31)*dd_an
                          g1x_an = g1x_an + dxo*dan31
                          g1y_an = g1y_an + dyo*dan31
                          g1z_an = g1z_an + dzo*dan31
                          gb0_an = gb0_an +     dan31
                          gbxx_an = gbxx_an + dxo2*dan31
                          gbyy_an = gbyy_an + dyo2*dan31
                          gbzz_an = gbzz_an + dzo2*dan31
                          gbxy_an = gbxy_an + dxyo*dan31
                          gbxz_an = gbxz_an + dxzo*dan31
                          gbyz_an = gbyz_an + dyzo*dan31
                       endif
 280                   CONTINUE
                    ENDDO
 290                CONTINUE
                 ENDDO
 300             CONTINUE
              ENDDO
C
C---If no grid points was involved in calculation then skip follwoing 
C---derivative calculations. It might happen for some symmetry related
C---atoms or atoms outside asymmetric unit. (In many space groups
C---asymmetric unit used here is much larger than real one)
c          IF(NPOINTS.LE.0) GOTO 400
              CALL ANISO_INVERT_1DERIV(NGAUS,UL_ANISO,DET_U,UL_INVERT,
     +             DDET_UDU,DUDU)
              if(anom.and.cs_anom(il)) then
                 call aniso_invert_1deriv1(ul_aniso_an,det_u_an,
     &                ul_invert_an,ddet_udu_an,dudu_an)
              endif
C     
C----Calculate derivatives wrt current positional parameters
              GXP(1) = 0.0
              GXP(2) = 0.0
              GXP(3) = 0.0
              DO   I=1,6
                 GU(I) = 0.0
                 gu_anom(i) = 0.0
              ENDDO
              GQQ = 0.0
              gqq_anom = 0.0
              DO   IG=1,NGAUS
                 GXP(1) = GXP(1) + CL1(IG)*(UL_INVERT(1,IG)*G1X(IG) + 
     +                UL_INVERT(4,IG)*G1Y(IG) +
     +                UL_INVERT(5,IG)*G1Z(IG))

                 GXP(2) = GXP(2) + CL1(IG)*(UL_INVERT(4,IG)*G1X(IG) + 
     +                UL_INVERT(2,IG)*G1Y(IG) +
     +                UL_INVERT(6,IG)*G1Z(IG))
                 
                 GXP(3) = GXP(3) + CL1(IG)*(UL_INVERT(5,IG)*G1X(IG) + 
     +                UL_INVERT(6,IG)*G1Y(IG) +
     +                UL_INVERT(3,IG)*G1Z(IG))
C     
c---  Same thing for B (or) U-values
                 DO    I=1,6
                    GU(I) = GU(I) + CLB(IG)*(DDET_UDU(I,IG)*GB0(IG) + 
     +                   DUDU(1,I,IG)*GBXX(IG) + DUDU(2,I,IG)*GBYY(IG) + 
     +                   DUDU(3,I,IG)*GBZZ(IG) + 
     +                   2.0*(DUDU(4,I,IG)*GBXY(IG) +
     +                   DUDU(5,I,IG)*GBXZ(IG) + DUDU(6,I,IG)*GBYZ(IG)))
                 ENDDO
                 GQQ = GQQ +CLQ(IG)*GB0(IG)
              ENDDO
c
c---  anomolous part
              
              if(anom.and.cs_anom(il)) then
                 GXP(1) = GXP(1) + cl_an*(UL_INVERT_an(1)*G1X_an + 
     +                UL_INVERT_an(4)*G1Y_an +
     +                UL_INVERT_an(5)*G1Z_an)
                 
                 GXP(2) = GXP(2) + cl_an*(UL_INVERT_an(4)*G1X_an + 
     +                UL_INVERT_an(2)*G1Y_an +
     +                UL_INVERT_an(6)*G1Z_an)
                 
                 GXP(3) = GXP(3) + cl_an*(UL_INVERT_an(5)*G1X_an + 
     +                UL_INVERT_an(6)*G1Y_an +
     +                UL_INVERT_an(3)*G1Z_an)
C     
c---  Same thing for B (or) U-values
                 DO    I=1,6
                    GU_anom(I) = GU_anom(I) + 
     &                   clb_an*(DDET_UDU_an(i)*gb0_an + 
     +                   DUDU_an(1,I)*GBXX_an + DUDU_an(2,I)*GBYY_an + 
     +                   DUDU_an(3,I)*GBZZ_an + 
     +                   2.0*(DUDU_an(4,I)*GBXY_an +
     +                   DUDU_an(5,i)*GBXZ_an + DUDU_an(6,i)*GBYZ_an))
                 ENDDO
c            GQQ = GQQ + CLQ_an*GB0_an
                 gqq_anom = gqq_anom + clq_an*gb0_an
c
c--We may want to keep anom occup as a separate array
              endif
C
C---If current atom is symmetry related to original atom then calculate 
C---derivative of original one by using symmetry operators (simple chain
C---rule)
c     IF(ISYM.GT.1) THEN
              xyz1 = matmul(transpose(cs_frac_to_ort),gxp)
              xyz1 = matmul(transpose(rot(1:3,1:3,isym)),xyz1)
              xyz1  = matmul(transpose(cs_ort_to_frac),xyz1)
              gxp = matmul(transpose(ncs_c_rot(1:3,1:3,in)),xyz1)

c              CALL MAT2VECT(3,3,CS_FRAC_TO_ORT,GXP,XYZ,ERROR)
c            CALL MAT2VECT(3,3,ROT(1,1,ISYM),XYZ,XYZ1,ERROR)
c            CALL MAT2VECT(3,3,CS_ORT_TO_FRAC,XYZ1,GXP,ERROR)

              gu11 = matmul(uucell2orth,gu)
              guu  = matmul(RealSymm_Aniso(1:6,1:6,isym),gu11)
              gu11 = matmul(uuorth2cell,guu)
              gu   = matmul(uu_ncs(1:6,1:6,in),gu11)
c            CALL MAT2VEC(6,6,UUCELL2ORTH,GU,GU11,ERROR)
c            CALL MAT2VEC(6,6,RealSymm_Aniso(1,1,ISYM),GU11,GUU,ERROR)
c            CALL MAT2VEC(6,6,UUORTH2CELL,GUU,GU,ERROR)
c
c--   For anom
              if(anom.and.cs_anom(il)) then
                 gu11 = matmul(uucell2orth,gu_anom)
                 guu  = matmul(RealSymm_Aniso(1:6,1:6,isym),gu11)
                 gu11 = matmul(uuorth2cell,guu)
                 gu_anom   = matmul(uu_ncs(1:6,1:6,in),gu11)
c               CALL MAT2VEC(6,6,UUCELL2ORTH,GU_anom,GU11,ERROR)
c               CALL MAT2VEC(6,6,RealSymm_Aniso(1,1,ISYM),GU11,GUU,ERROR)
c               CALL MAT2VEC(6,6,UUORTH2CELL,GUU,GU_anom,ERROR)
              endif
c           ENDIF
              GX(IXT  ) = GX(IXT  ) + GXP(1)
              GX(IXT+1) = GX(IXT+1) + GXP(2)
              GX(IXT+2) = GX(IXT+2) + GXP(3)
              DO     IANISO = 0,5
                 GU1(IT+IANISO) = GU1(IT+IANISO) - GU(IANISO+1)
              ENDDO
              if(anom.and.cs_anom(il)) then
                 gu1_anom(it:(it+5)) = gu1_anom(it:(it+5)) - 
     &                gu_anom(1:6)
                 gu1(it:(it+5)) = gu1(it:(it+5)) - gu_anom(1:6)
              endif
c     d          IF(OCCUP_REF(IA).GT.1) GQ(IQ) = GQ(IQ) + GQQ
c     keeping anom contrib separate
ccc   GQ(IQ) = GQ(IQ) + GQQ + gqq_anom
              gq_anom(iq) = gq_anom(iq) + gqq_anom
              gq(iq) = gq(iq) + gqq
 400          CONTINUE
           ENDDO
C
        enddo
 498    CONTINUE
        IXT = IXT + 3
        IF(U_ANISO_mod(2,IA,im).LE.0.0) THEN
          IT = IT + 1
        ELSE 
          IT = IT + 6
        ENDIF
        IQ = IQ + 1
 500    CONTINUE
      ENDDO
      enddo
      RETURN
      END
c
      SUBROUTINE ANISO_INVERT1(BL_ANISO,DET_B,BL_INVERT)
      implicit none
C
C---Calculates inversion of matrices and its determinant (of original matrix)
C---for anisotropic
C---B-values. Uses symmetricity of Aniso B tensor. This subrotine uses
C---Kronekker's rule ofr calculation inversion of matrices
      REAL BL_ANISO(6),DET_B,BL_INVERT(6)
c
      integer ianiso
C
C---First calculate minors of anisotropic tensor
      BL_INVERT(1) = 
     +     BL_ANISO(2)*BL_ANISO(3) - BL_ANISO(6)**2
      BL_INVERT(2) = 
     +     BL_ANISO(1)*BL_ANISO(3) - BL_ANISO(5)**2
      BL_INVERT(3) = 
     +     BL_ANISO(1)*BL_ANISO(2) - BL_ANISO(4)**2
      BL_INVERT(4) = 
     +     -BL_ANISO(3)*BL_ANISO(4) +
     +     BL_ANISO(5)*BL_ANISO(6)
      BL_INVERT(5) = 
     +     BL_ANISO(4)*BL_ANISO(6) -
     +     BL_ANISO(5)*BL_ANISO(2)
      BL_INVERT(6) = 
     +     -BL_ANISO(1)*BL_ANISO(6) +
     +     BL_ANISO(4)*BL_ANISO(5)
      DET_B = 0.0
C
C----Calulate determinants.
      DET_B = (BL_ANISO(1)*BL_INVERT(1)+
     +     BL_ANISO(4)*BL_INVERT(4)+
     +     BL_ANISO(5)*BL_INVERT(5))
C
C---Now calculate inversion of matrices using Kronekkers rule
      DO     IANISO = 1,6
         BL_INVERT(IANISO) = BL_INVERT(IANISO)/DET_B
      ENDDO
C
C----Derivatives here or not here that is the question
      END
C
      SUBROUTINE ANISO_INVERT(ngaus,BL_ANISO,DET_B,BL_INVERT)
      implicit none
C
C---Calculates inversion of matrices and its determinant (of original matrix)
C---for anisotropic
C---B-values. Uses symmetricity of Aniso B tensor. This subrotine uses
C---Kronekker's rule ofr calculation inversion of matrices
      integer ngaus
      REAL BL_ANISO(6,NGAUS),DET_B(NGAUS),BL_INVERT(6,NGAUS)
c
      integer ig,ianiso
C
C---First calculate minors of anisotropic tensor
      DO    IG=1,NGAUS
         BL_INVERT(1,IG) = 
     +          BL_ANISO(2,IG)*BL_ANISO(3,IG) - BL_ANISO(6,IG)**2
         BL_INVERT(2,IG) = 
     +          BL_ANISO(1,IG)*BL_ANISO(3,IG) - BL_ANISO(5,IG)**2
         BL_INVERT(3,IG) = 
     +          BL_ANISO(1,IG)*BL_ANISO(2,IG) - BL_ANISO(4,IG)**2
         BL_INVERT(4,IG) = 
     +         -BL_ANISO(3,IG)*BL_ANISO(4,IG) +
     +          BL_ANISO(5,IG)*BL_ANISO(6,IG)
         BL_INVERT(5,IG) = 
     +          BL_ANISO(4,IG)*BL_ANISO(6,IG) -
     +          BL_ANISO(5,IG)*BL_ANISO(2,IG)
         BL_INVERT(6,IG) = 
     +         -BL_ANISO(1,IG)*BL_ANISO(6,IG) +
     +          BL_ANISO(4,IG)*BL_ANISO(5,IG)
         DET_B(IG) = 0.0
       ENDDO
C
C----Calulate determinants.
       DO    IG=1,NGAUS
         DET_B(IG) = (BL_ANISO(1,IG)*BL_INVERT(1,IG)+
     +                BL_ANISO(4,IG)*BL_INVERT(4,IG)+
     +                BL_ANISO(5,IG)*BL_INVERT(5,IG))
       ENDDO
C
C---Now calculate inversion of matrices using Kronekkers rule
       DO    IG=1,NGAUS
          DO     IANISO = 1,6
             BL_INVERT(IANISO,IG) = BL_INVERT(IANISO,IG)/DET_B(IG)
          ENDDO
       ENDDO
C
C----Derivatives here or not here that is the question
       END
c
      SUBROUTINE ANISO_INVERT_1DERIV1(UL_ANISO,DET_U,UL_INVERT,
     +                        DDET_UDU,DUDU)
      implicit none
C
C--Calculates derivatives of inverted matrix with respect to matrix elements
C--necessary to calculate gradients
      REAL UL_ANISO(6),DET_U,UL_INVERT(6)
      REAL DDET_UDU(6),DUDU(6,6)
c
      integer i,j
c     
      DDET_UDU(1) =      UL_INVERT(1)
      DDET_UDU(2) =      UL_INVERT(2) 
      DDET_UDU(3) =      UL_INVERT(3)
      DDET_UDU(4) =  2.0*UL_INVERT(4)
      DDET_UDU(5) =  2.0*UL_INVERT(5)
      DDET_UDU(6) =  2.0*UL_INVERT(6)
      DO   I=1,6
         DO   J=1,6
            DUDU(I,J) = -UL_INVERT(I)*DDET_UDU(J)
         ENDDO
      ENDDO
      DUDU(2,1) = DUDU(2,1) +     UL_ANISO(3)/DET_U
      DUDU(3,1) = DUDU(3,1) +     UL_ANISO(2)/DET_U 
      DUDU(6,1) = DUDU(6,1) -     UL_ANISO(6)/DET_U
      
      DUDU(1,2) = DUDU(1,2) +     UL_ANISO(3)/DET_U
      DUDU(3,2) = DUDU(3,2) +     UL_ANISO(1)/DET_U
      DUDU(5,2) = DUDU(5,2) -     UL_ANISO(5)/DET_U
      
      DUDU(1,3) = DUDU(1,3) +     UL_ANISO(2)/DET_U 
      DUDU(2,3) = DUDU(2,3) +     UL_ANISO(1)/DET_U 
      DUDU(4,3) = DUDU(4,3) -     UL_ANISO(4)/DET_U
      
      DUDU(3,4) = DUDU(3,4) - 2.0*UL_ANISO(4)/DET_U
      DUDU(4,4) = DUDU(4,4) -     UL_ANISO(3)/DET_U
      DUDU(5,4) = DUDU(5,4) +     UL_ANISO(6)/DET_U
      DUDU(6,4) = DUDU(6,4) +     UL_ANISO(5)/DET_U
      
      DUDU(2,5) = DUDU(2,5) - 2.0*UL_ANISO(5)/DET_U
      DUDU(4,5) = DUDU(4,5) +     UL_ANISO(6)/DET_U
      DUDU(5,5) = DUDU(5,5) -     UL_ANISO(2)/DET_U
      DUDU(6,5) = DUDU(6,5) +     UL_ANISO(4)/DET_U
      
      DUDU(1,6) = DUDU(1,6) - 2.0*UL_ANISO(6)/DET_U
      DUDU(4,6) = DUDU(4,6) +     UL_ANISO(5)/DET_U
      DUDU(5,6) = DUDU(5,6) +     UL_ANISO(4)/DET_U
      DUDU(6,6) = DUDU(6,6) -     UL_ANISO(1)/DET_U

      END
C
      SUBROUTINE ANISO_INVERT_1DERIV(ngaus,UL_ANISO,DET_U,UL_INVERT,
     +                        DDET_UDU,DUDU)
      implicit none
C
C--Calculates derivatives of inverted matrix with respect to matrix elements
C--necessary to calculate gradients
      integer ngaus
      REAL UL_ANISO(6,NGAUS),DET_U(NGAUS),UL_INVERT(6,NGAUS)
      REAL DDET_UDU(6,NGAUS),DUDU(6,6,NGAUS)
c
      integer ig,i,j
c
       DO     IG=1,NGAUS
          DDET_UDU(1,IG) =      UL_INVERT(1,IG)
          DDET_UDU(2,IG) =      UL_INVERT(2,IG) 
          DDET_UDU(3,IG) =      UL_INVERT(3,IG)
          DDET_UDU(4,IG) =  2.0*UL_INVERT(4,IG)
          DDET_UDU(5,IG) =  2.0*UL_INVERT(5,IG)
          DDET_UDU(6,IG) =  2.0*UL_INVERT(6,IG)
          DO   I=1,6
            DO   J=1,6
              DUDU(I,J,IG) = -UL_INVERT(I,IG)*DDET_UDU(J,IG)
            ENDDO
          ENDDO
          DUDU(2,1,IG) = DUDU(2,1,IG) +     UL_ANISO(3,IG)/DET_U(IG)
          DUDU(3,1,IG) = DUDU(3,1,IG) +     UL_ANISO(2,IG)/DET_U(IG) 
          DUDU(6,1,IG) = DUDU(6,1,IG) -     UL_ANISO(6,IG)/DET_U(IG)

          DUDU(1,2,IG) = DUDU(1,2,IG) +     UL_ANISO(3,IG)/DET_U(IG)
          DUDU(3,2,IG) = DUDU(3,2,IG) +     UL_ANISO(1,IG)/DET_U(IG)
          DUDU(5,2,IG) = DUDU(5,2,IG) -     UL_ANISO(5,IG)/DET_U(IG)
 
          DUDU(1,3,IG) = DUDU(1,3,IG) +     UL_ANISO(2,IG)/DET_U(IG) 
          DUDU(2,3,IG) = DUDU(2,3,IG) +     UL_ANISO(1,IG)/DET_U(IG) 
          DUDU(4,3,IG) = DUDU(4,3,IG) -     UL_ANISO(4,IG)/DET_U(IG)

          DUDU(3,4,IG) = DUDU(3,4,IG) - 2.0*UL_ANISO(4,IG)/DET_U(IG)
          DUDU(4,4,IG) = DUDU(4,4,IG) -     UL_ANISO(3,IG)/DET_U(IG)
          DUDU(5,4,IG) = DUDU(5,4,IG) +     UL_ANISO(6,IG)/DET_U(IG)
          DUDU(6,4,IG) = DUDU(6,4,IG) +     UL_ANISO(5,IG)/DET_U(IG)

          DUDU(2,5,IG) = DUDU(2,5,IG) - 2.0*UL_ANISO(5,IG)/DET_U(IG)
          DUDU(4,5,IG) = DUDU(4,5,IG) +     UL_ANISO(6,IG)/DET_U(IG)
          DUDU(5,5,IG) = DUDU(5,5,IG) -     UL_ANISO(2,IG)/DET_U(IG)
          DUDU(6,5,IG) = DUDU(6,5,IG) +     UL_ANISO(4,IG)/DET_U(IG)

          DUDU(1,6,IG) = DUDU(1,6,IG) - 2.0*UL_ANISO(6,IG)/DET_U(IG)
          DUDU(4,6,IG) = DUDU(4,6,IG) +     UL_ANISO(5,IG)/DET_U(IG)
          DUDU(5,6,IG) = DUDU(5,6,IG) +     UL_ANISO(4,IG)/DET_U(IG)
          DUDU(6,6,IG) = DUDU(6,6,IG) -     UL_ANISO(1,IG)/DET_U(IG)

       ENDDO
       END

      SUBROUTINE FBS2ANISO(NGAUS,MXSCAT,NSCAT,FBB,FU_ANISO)
C
      IMPLICIT NONE
      INCLUDE 'const.fh'
C
C---Converts B-values of atomic form factors to anisotropic form.
C---It is necessary if cell is not orthogonal
      INTEGER NGAUS,MXSCAT,NSCAT
      REAL FBB(NGAUS,MXSCAT)
      REAL FU_ANISO(6,NGAUS,MXSCAT)
C
      INTEGER ISCAT,IG

      DO   ISCAT=1,NSCAT
        DO    IG=1,NGAUS
          FU_ANISO(1,IG,ISCAT) = FBB(IG,ISCAT)/PISQ8
          FU_ANISO(2,IG,ISCAT) = FBB(IG,ISCAT)/PISQ8
          FU_ANISO(3,IG,ISCAT) = FBB(IG,ISCAT)/PISQ8
          FU_ANISO(4,IG,ISCAT) = 0.0
          FU_ANISO(5,IG,ISCAT) = 0.0
          FU_ANISO(6,IG,ISCAT) = 0.0
        ENDDO
      ENDDO
      RETURN
      END
C
      SUBROUTINE BISO2ANISO(BISO,UANISO)
      implicit none
C
C---Converts B-values of atomic form factors to anisotropic U form.
      real biso
      REAL UANISO(6)

      UANISO(1) = BISO
      UANISO(2) = BISO
      UANISO(3) = BISO
      UANISO(4) = 0.0
      UANISO(5) = 0.0
      UANISO(6) = 0.0

      RETURN
      END
C
      SUBROUTINE UANISO_CELL2ORTH(U_CELL_ANISO,U_ORTH_ANISO)
      use CellAndSymmetry
      implicit none
C
C----Converts anisotropic U values from cell edges to orthogonal system
C----Im REAL
      REAL U_CELL_ANISO(6),U_ORTH_ANISO(6)
      
      integer i,j
                                !
                                !   body
      DO     I=1,6
         U_ORTH_ANISO(I) = 0.0
         DO    J=1,6
            U_ORTH_ANISO(I) =  U_ORTH_ANISO(I)+
     +               U_CELL_ANISO(J) * UUCELL2ORTH(J,I)
         ENDDO
      ENDDO
      RETURN
      END

      SUBROUTINE UANISO_ORTH2CELL(U_CELL_ANISO,U_ORTH_ANISO)
      use CellAndSymmetry
C
C----Converts anisotropic U values from orhtogonal system to cell edges 
C----In REAL


      REAL U_CELL_ANISO(6),U_ORTH_ANISO(6)
                                !  
                                !  locals
      integer i,j
                                !
                                !   body
      DO     I=1,6
         U_CELL_ANISO(I) = 0.0
         DO    J=1,6
            U_CELL_ANISO(I) = U_CELL_ANISO(I) + 
     +                         U_ORTH_ANISO(J)*UUORTH2CELL(J,I)
         ENDDO
      ENDDO 
      RETURN
      END
C
      SUBROUTINE ATLIST_ANISO(XFRAC_input,
     +     UANISO_INIT,uaniso_init_an,XA_list,UANISO_LIST,
     &     uaniso_list_an,
     +     XLOW,YLOW,ZLOW,XUPPER,YUPPER,ZUPPER,INDSYM_list,
     +     NATOM_list)
      use CellAndSymmetry
      implicit none
                                !
      INCLUDE 'vitals.fh'
C
C----Finds list of atoms which has something to do with enlarged 
C----asymmetric unit after application of symmetry operations.
C----Could be used for atoms with anisotropic B-values.
      integer natom_list
      real xlow,ylow,zlow,xupper,yupper,zupper
      REAL    XFRAC_input(3),XA_list(3,*),UANISO_INIT(6)
      real    uaniso_init_an(6)
      real    UANISO_LIST(6,*)
      real    uaniso_list_an(6,*)
      INTEGER INDSYM_list(*)
                                !
                                !   locals
      integer i,j,isym
      real xt,yt,zt
      
C----------------------------------------------------------------
C-----Input 
C-----
C----- XFRAC_input,
C----- YFRAC_input,
C----- ZFRAC_input  positional paramters of atoms in fractional 
C-----              coordinates
C----- UANISO_INIT  thermal parameters in cell edges (angstroms^2)
C----- XLOW,
C----- YLOW,
C----- ZLOW,
C----- XUPPER,
C----- YUPPER,
C----- ZUPPER       lower and upper limits of asymmetric unit for 
C-----              enlarging (in fractional coordiates)
C-----
C-----Output
C-----
C----- Xa_list      list of coordinates
C----- UANISO_LIST  U-values for symmetry related atoms 
C----- INDSYM_list  corresponding symmetry operation
C----- NATOM_list   number of atoms in the list 
C-----
C---------------------------------------------------------------
      
      NATOM_list = 0
      DO    ISYM=1,NumSymmetry
        XT = RealSymmMatrx(1,1,ISYM)*XFRAC_input(1) + 
     +       RealSymmMatrx(1,2,ISYM)*XFRAC_input(2) +
     +       RealSymmMatrx(1,3,ISYM)*XFRAC_input(3) + 
     +       RealSymmMatrx(1,4,ISYM)

        YT = RealSymmMatrx(2,1,ISYM)*XFRAC_input(1) + 
     +       RealSymmMatrx(2,2,ISYM)*XFRAC_input(2) +
     +       RealSymmMatrx(2,3,ISYM)*XFRAC_input(3) + 
     +       RealSymmMatrx(2,4,ISYM)

        ZT = RealSymmMatrx(3,1,ISYM)*XFRAC_input(1) + 
     +       RealSymmMatrx(3,2,ISYM)*XFRAC_input(2) +
     +       RealSymmMatrx(3,3,ISYM)*XFRAC_input(3) +  
     +       RealSymmMatrx(3,4,ISYM)
C
C---Check if atom is inside enlarged asymmetric unit
20      IF(XT.LT.XLOW)GO TO 21
        XT=XT-1.
        GO TO 20
21      XT=XT+1.
        IF(XT.LT.XLOW) GO TO 21
30      IF(YT.LT.YLOW) GO TO 31
        YT=YT-1.
        GO TO 30
31      YT=YT+1.
        IF(YT.LT.YLOW)GO TO 31
40      IF(ZT.LT.ZLOW)GO TO 41
        ZT=ZT-1.
        GO TO 40
41      ZT=ZT+1.
        IF(ZT.LT.ZLOW)GO TO 41
70      IF(XT.GT.XUPPER)GO TO 90
        IF(YT.GT.YUPPER)GO TO 90
        IF(ZT.GT.ZUPPER)GO TO 90
C
C---Atom is inside enlarged asymmetric unit. Store its coordinates and
C---symmetry operation by which this atom came into asymmetric unit
        NATOM_list              = NATOM_list + 1
        XA_list(1,NATOM_list)   = XT
        XA_list(2,NATOM_list)   = YT
        XA_list(3,NATOM_list)   = ZT
        INDSYM_list(NATOM_list) = ISYM
        DO   I=1,6
          UANISO_LIST(I,NATOM_list) = 0.0
          uaniso_list_an(i,natom_list) = 0.0
          DO   J=1,6
            UANISO_LIST(I,NATOM_list) = UANISO_LIST(I,NATOM_list) + 
     +           RealSymm_Aniso(J,I,ISYM)*UANISO_INIT(J)
            UANISO_LIST_an(I,NATOM_list)=UANISO_LIST_an(I,NATOM_list)+ 
     +           RealSymm_Aniso(J,I,ISYM)*UANISO_INIT_an(J)
          ENDDO
        ENDDO
90      CONTINUE
      ENDDO
      RETURN
      END
C
      SUBROUTINE APPLY_CONV2U(UANISO,UANISO1,R_CONV)
C
C---Applies conversion matrix to aniso U
      REAL UANISO(6),UANISO1(6),R_CONV(6,6)
      LOGICAL ERROR
C
      CALL MAT2VECT(6,6,R_CONV,UANISO,UANISO1,ERROR)
      RETURN
      END
C
      SUBROUTINE ALLBS2ANISOU(nmodel)
      IMPLICIT NONE
C
C---Converts isotropic Bs to anisotropic U values
      INCLUDE 'vitals.fh'
      INCLUDE 'atom_com.fh'
      include 'models.fh'
      INTEGER IA,im,nmodel
C
C----If atom is not already anisotropic make it so.
      NANISO_ATOMS = 0
      N_ANISO      = 0
      do im=1,nmodel
        DO  IA=1,N_ATOM_mod(im)
          IF(U_ANISO_mod(2,IA,im).LE.0.0) THEN
cd          IF(CS_ELEMENT(ID_SF(IA)).NE.'H'.AND.
cd     &       CS_ELEMENT(ID_SF(IA)).NE.'H-1') THEN
            if (im.eq.1) U_ANISO(2,IA) = U_ANISO(1,IA)
            if (im.eq.1) U_ANISO(3,IA) = U_ANISO(1,IA)
            if (im.eq.1) U_ANISO(4,IA) = 0.0
            if (im.eq.1) U_ANISO(5,IA) = 0.0
            if (im.eq.1) U_ANISO(6,IA) = 0.0
            U_ANISO_mod(2,IA,im) = U_ANISO_mod(1,IA,im)
            U_ANISO_mod(3,IA,im) = U_ANISO_mod(1,IA,im)
            U_ANISO_mod(4,IA,im) = 0.0
            U_ANISO_mod(5,IA,im) = 0.0
            U_ANISO_mod(6,IA,im) = 0.0
            NANISO_ATOMS = NANISO_ATOMS + 1
            N_ANISO      = N_ANISO + 1
cd         ENDIF
          ENDIF
        ENDDO
      enddo
cd      NANISO_ATOMS = N_ATOM
cd      N_ANISO      = N_ATOM
      END 
C
      SUBROUTINE CHECK_TLS_TENSORTS(TMAT,LMAT,SMAT,IFLAG)
      IMPLICIT NONE
C
      INCLUDE 'const.fh'
      INTEGER IFLAG
      REAL TMAT(6),LMAT(6),SMAT(8)
      REAL UANISO0(6,6),EVALUE(6),WORKSPACE(100)
      INTEGER I,J,LWORK,INFO
C
      IFLAG = 0
      LWORK = 10
      UANISO0(1,1) = TMAT(1)
      UANISO0(2,2) = TMAT(2)
      UANISO0(3,3) = TMAT(3)
      UANISO0(1,2) = TMAT(4)
      UANISO0(1,3) = TMAT(5)
      UANISO0(2,3) = TMAT(6)

      UANISO0(4,4) = LMAT(1)
      UANISO0(5,5) = LMAT(2)
      UANISO0(6,6) = LMAT(3)
      UANISO0(4,5) = LMAT(4)
      UANISO0(4,6) = LMAT(5)
      UANISO0(5,6) = LMAT(6)
C
C---Now add S tensor. Assume s11 + s22 + s33 = 0.0
      UANISO0(1,4) = (SMAT(2)-SMAT(1))/3.0
      UANISO0(2,5) = (SMAT(2) + 2.0*SMAT(1))/3.0
      UANISO0(3,5) = -(SMAT(1) + 2.0*SMAT(2))/3.0
      UANISO0(2,4) = SMAT(3)
      UANISO0(3,4) = SMAT(4)
      UANISO0(3,5) = SMAT(5)
      UANISO0(1,5) = SMAT(6)
      UANISO0(2,6) = SMAT(7)
      UANISO0(3,6) = SMAT(8)
      DO   I=1,5
         DO   J=I+1,6
           UANISO0(J,I) = UANISO0(I,J)
         ENDDO
      ENDDO
      call seig3dim(uaniso0,evalue,info)
      if(info.gt.0) then
         write(*,*)'problem in allbs2aniso',info
         stop
      endif
      DO   I=1,6
        IF(EVALUE(I).LT.0.0) THEN
          WRITE(*,*)'Eigenvalue is less than 0. Reset it'
          EVALUE(I) = 0.0
          IFLAG = 1
        ENDIF
        IF(EVALUE(I).GT.20.0/(RTODEG*RTODEG)) THEN
          WRITE(*,*)'Eigenvalue too large. Reset it'
          EVALUE(I) = 20.0/(RTODEG*RTODEG)
          IFLAG = 1
        ENDIF
cd        EVALUE(I) = AMAX1(0.0,AMIN1(EVALUE(I),30.0/(RTODEG*RTODEG)))
      ENDDO
cd      CALL EIGEN2U(EVALUE,UANISO0,LMAT)
C
C---Now return back to TLS parameters
      RETURN
      END
c
      subroutine allanisous2b(nmodel)
      implicit none
      include 'atom_com.fh'
      include 'models.fh'
c
c---locals
      integer ia,im,nmodel
      real    uloc
c
c---Convert all aniso U to isotropic Bs
      do im=1,nmodel
        do ia=1,n_atom_mod(im)
          if(im.eq.1) b_flag(ia) = 0
          if(u_aniso_mod(2,ia,im).ne.0.0) then
            if(u_aniso_mod(2,ia,im).gt.0.0) then
               uloc = sum(u_aniso_mod(1:3,ia,im))/3.
               if (im.eq.1) u_aniso(1,ia) = uloc
               if (im.eq.1) u_aniso(2:6,ia) = 0.0
               u_aniso_mod(1,ia,im) = uloc
               u_aniso_mod(2:6,ia,im) = 0.0
            else
c---  We have a problem. Try to sort out it. Take maximum of u(1:3) and use
c---  it as iso equivalent
               uloc = max(0.1,maxval(u_aniso_mod(1:3,ia,im)))
               if (im.eq.1) u_aniso(1,ia) = uloc
               if (im.eq.1) u_aniso(2:6,ia) = 0.0
               u_aniso_mod(1,ia,im) = uloc
               u_aniso_mod(2:6,ia,im) = 0.0
            endif
          endif
        enddo
      enddo
      return
      end
C
      SUBROUTINE CHECK_U_VALUES(nmodel)
      use CellAndSymmetry
      use refi_flags
      IMPLICIT NONE
C
C---Checks validity of U values. In isotropic case if U is
C---outside predefined limit UMIN, UMAX makes it inside it. In case
C---anisotropic U finds eigenvalues checks if they are outside
C---predefined limit. If they are makes them inside
      INCLUDE 'atom_com.fh'
      INCLUDE 'models.fh'
      INCLUDE 'vitals.fh'
C
      integer nmodel
C
      REAL UANISO0(3,3),UANISO1(6),EVALUE(3),WORKSPACE(20)
      CHARACTER LINE*256,AT_FULL*15
C
      INTEGER IA,LWORK,INFO,I,II,IERROR,IANISO,im

      LWORK = 20
      do im=1,nmodel
        DO    IA=1,N_ATOM_mod(im)
c         if(u_aniso(2,ia).lt.0.0) then
c            write(*,*)'disaster',ia
c            stop
c         endif
          IF(U_ANISO_mod(2,IA,im).LE.0.0) THEN
C
C---Atom is isotropic. put it inside predefined limit.
            IF(U_ANISO_mod(1,IA,im).LT.BResetMin) THEN
              if (im.eq.1) U_ANISO(1,IA) = BResetMin
              U_ANISO_mod(1,IA,im) = BResetMin
            ENDIF
            IF(U_ANISO_mod(1,IA,im).GT.BResetMax) THEN
              if (im.eq.1) U_ANISO(1,IA) = BResetMax
              U_ANISO_mod(1,IA,im) = BResetMax
            ENDIF
          ELSE
C
C---Atom is anisotropic
            UANISO0(1,1) = U_ANISO_mod(1,IA,im)
            UANISO0(2,2) = U_ANISO_mod(2,IA,im)
            UANISO0(3,3) = U_ANISO_mod(3,IA,im)
            UANISO0(1,2) = U_ANISO_mod(4,IA,im)
            UANISO0(1,3) = U_ANISO_mod(5,IA,im)
            UANISO0(2,3) = U_ANISO_mod(6,IA,im)
            UANISO0(2,1) = UANISO0(1,2)
            UANISO0(3,1) = UANISO0(1,3)
            UANISO0(3,2) = UANISO0(2,3)
            call seig3dim(uaniso0,evalue,info)
            if(info.gt.0) then
              write(*,*)'Problem in check_u_valuse',info
              stop
            endif
C
C---Check if atom has small eigen value

            IF(EVALUE(1).LT.BResetMin) THEN
              CALL FULL_ATOM_NAME(IA,AT_FULL,IERROR)
cd            WRITE(LINE,'(A,A,A)')'Atom ',AT_FULL,
cd     +    ' tends to have small eigenvalue. Reset it'
cd            CALL ERRWRT(-1,LINE)
cd            WRITE(LINE,'(A,3F10.4)')'Eigenvalues ',
cd     +             EVALUE(1),EVALUE(2),EVALUE(3)
cd            CALL ERRWRT(-1,LINE)
cd            WRITE(LINE,'(A,6F10.4)')' U before setting ',
cd     +                   (U_ANISO(II,IA),II=1,6)
cd            CALL ERRWRT(-1,LINE)
              EVALUE(1) = AMAX1(BResetMin,EVALUE(1))
              EVALUE(2) = AMAX1(BResetMin,EVALUE(2))
              EVALUE(3) = AMAX1(BResetMin,EVALUE(3))
              CALL EIGEN2U(EVALUE,UANISO0,UANISO1)
              DO    IANISO=1,6
                if (im.eq.1) U_ANISO(IANISO,IA) = UANISO1(IANISO)
                U_ANISO_mod(IANISO,IA,im) = UANISO1(IANISO)
              ENDDO
cd            WRITE(LINE,'(A,6F10.4)')' U after setting ',
cd     +                   (U_ANISO(II,IA),II=1,6)
cd            CALL ERRWRT(-1,LINE)
            ENDIF
C
C---Check if atom has too big eigenvalue
            IF(EVALUE(3).GT.BResetMax ) THEN
              CALL FULL_ATOM_NAME(IA,AT_FULL,IERROR)
cd            WRITE(LINE,'(A,A,A)')'Atom ',AT_FULL,
cd     +          ' tends to have large eigenvalue. Reset it'
cd            CALL ERRWRT(-1,LINE)
cd            WRITE(LINE,'(A,3F10.3)')'Eigenvalues ',
cd     +                  EVALUE(1),EVALUE(2),EVALUE(3)
cd            CALL ERRWRT(-1,LINE)
cd            WRITE(LINE,'(A,6F10.4)')' U before setting ',
cd     +                   (U_ANISO(II,IA),II=1,6)
              EVALUE(1) = AMIN1(BResetMax,EVALUE(1))
              EVALUE(2) = AMIN1(BResetMax,EVALUE(2))
              EVALUE(3) = AMIN1(BResetMax,EVALUE(3))
              CALL EIGEN2U(EVALUE,UANISO0,UANISO1)
              DO    IANISO=1,6
                if (im.eq.1) U_ANISO(IANISO,IA) = UANISO1(IANISO)
                U_ANISO_mod(IANISO,IA,im) = UANISO1(IANISO)
              ENDDO
cd            WRITE(LINE,'(A,6F10.4)')' U after setting ',
cd     +                   (U_ANISO(II,IA),II=1,6)
cd            CALL ERRWRT(-1,LINE)
            ENDIF
          ENDIF
        ENDDO
      enddo

      END
C
      SUBROUTINE EIGEN2U(U0,EV,U1)
      IMPLICIT NONE
C
C----Converts eigenvalues and eigenvaectors of U tensor to U tensor
C----itself. eigenvalues are U0(1),U0(2),U0(2), Evector is eigenvector
C----first eigenvalue and so on.
C----U1 is aniso U tensor. First 3 elements are diagonal terms
C----recall that U = EV U0diag EVt

      REAL U0(3),U1(6),EV(3,3)
C
C---Local variables
      REAL EV1(3,3),EV2(3,3)
      INTEGER I,J
C
      LOGICAL ERROR
C
      DO   I=1,3
        DO  J=1,3
          EV1(I,J) = EV(I,J)*U0(J)
        ENDDO
      ENDDO
      CALL MAT2MATT(3,3,EV1,EV,EV2,ERROR)

      U1(1) = EV2(1,1)
      U1(2) = EV2(2,2)
      U1(3) = EV2(3,3)

      U1(4) = EV2(1,2)
      U1(5) = EV2(1,3)
      U1(6) = EV2(2,3)

      RETURN
      END
C
      SUBROUTINE FIND_MIN_EIGEN(UANISO_INIT,UEIGEN_MIN)
      IMPLICIT NONE
C
C----Find minimum eigen value for aniso u value. Aniso U values 
C----are assumed to be in orthogonal coordinates

      REAL UANISO_INIT(6)
      REAL UEIGEN_MIN
C
      REAL UANISO0(3,3),EVALUE(3),WORKSPACE(20)
      INTEGER LWORK,INFO
C
C--First copy u values for special storage matrix.
      LWORK = 20
      UANISO0(1,1) = UANISO_INIT(1)
      UANISO0(2,2) = UANISO_INIT(2)
      UANISO0(3,3) = UANISO_INIT(3)
      UANISO0(1,2) = UANISO_INIT(4)
      UANISO0(1,3) = UANISO_INIT(5)
      UANISO0(2,3) = UANISO_INIT(6)
      UANISO0(2,1) = UANISO0(1,2)
      UANISO0(3,1) = UANISO0(1,3)
      UANISO0(3,2) = UANISO0(2,3)
      call seig3dim(uaniso0,evalue,info)
      if(info.gt.0) then
        write(*,*)'Problem in find_min_eigen',info
        stop
      endif

C
C---Find maximum of eigenvalues
      UEIGEN_MIN = EVALUE(1)
      END
C
      SUBROUTINE FIND_MAX_EIGEN(UANISO_INIT,UEIGEN_MAX)
      IMPLICIT NONE
C
C----Find maximum eigen value for aniso u value. Aniso U values 
C----are assumed to be in orthogonal coordinates

      REAL UANISO_INIT(6)
      REAL UEIGEN_MAX
C
      REAL UANISO0(3,3),EVALUE(3),WORKSPACE(20) 
      INTEGER LWORK,INFO
C
C--First copy u values for special storage matrix.
      LWORK = 20
      UANISO0(1,1) = UANISO_INIT(1)
      UANISO0(2,2) = UANISO_INIT(2)
      UANISO0(3,3) = UANISO_INIT(3)
      UANISO0(1,2) = UANISO_INIT(4)
      UANISO0(1,3) = UANISO_INIT(5)
      UANISO0(2,3) = UANISO_INIT(6)
      UANISO0(2,1) = UANISO0(1,2)
      UANISO0(3,1) = UANISO0(1,3)
      UANISO0(3,2) = UANISO0(2,3)
      call seig3dim(uaniso0,evalue,info)
      if(info.gt.0) then
        write(*,*)'Problem in find_max_eigen',info
        stop
      endif
C
C---Find maximum of eigenvalues
      UEIGEN_MAX = EVALUE(3)
      END
